/*
 * Folder.h
 *
 *  Created on: Jun 14, 2010
 *      Author: João V. Gomes
 */

#ifndef FOLDER_H_
#define FOLDER_H_

#ifdef __cplusplus
extern "C"
{
#endif
#include <sys/stat.h>
#include <sys/errno.h>
#include <string.h>
#include <dirent.h>
#include <unistd.h>
#ifdef __cplusplus
}
#endif

#include <string>
#include <fstream>
#include <vector>
#include <direxception.h>

#ifndef DIR_PERMISSIONS
#define DIR_PERMISSIONS 0744
#endif

class Folder {
public:
	Folder();
	Folder(const std::string &Path);
	virtual ~Folder();
	void WriteNewFile(const std::string &HostIP, const std::string &Msg) const;
	void WriteExistentFile(const std::string &HostIP, const std::string &Msg) const;
	void InitFolder(const std::string &Path);
	void ListFilesPath(std::vector<std::string> * Files) const;
	void ListFiles(std::vector<std::string> * Files) const;
	const std::string Path() const;
	const std::string CleanLastBar(const std::string &Path) const;

private:
	void CreateFolder(const std::string &Path);
	void CreateSubDir(const std::string &Path);
	const int IsDir(const std::string &Path) const;
	void WriteFile(const std::string &HostIP, const std::string &Msg, const std::_Ios_Openmode &flag) const;

	std::string FolderPath;
};

#endif /* FOLDER_H_ */
