#ifndef ETHPACKET_H
#define ETHPACKET_H

#include <packet.h>

/* tcpdump header (ether.h) defines ETHER_HDRLEN) */
#ifndef ETHER_HDRLEN
#define ETHER_HDRLEN 14
#endif

class EthPacket : public Packet
{
    public:
        explicit EthPacket(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data);
        explicit EthPacket(const long &TSsec, const long &TSmsec, const long &CapLength, const long &Length, const std::string &SrcMACaddr, const std::string &DstMACaddr);
        virtual ~EthPacket();
        std::string const * SrcMACaddr() const;
        std::string const * DstMACaddr() const;
        void init(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data);
        void init(const long &TSsec, const long &TSmsec, const long &CapLength, const long &Length, const std::string &SrcMACaddr, const std::string &DstMACaddr);
    protected:
        EthPacket();
        void init();
    private:
        std::string SourceMACaddr;
        std::string DestinationMACaddr;
};

#endif // ETHPACKET_H
