#ifndef IPPACKET_H
#define IPPACKET_H

#ifdef __cplusplus
extern "C"
{
#endif
#include <netinet/ip.h>
#include <arpa/inet.h>
#ifdef __cplusplus
}
#endif

#include <ethpacket.h>

class IPPacket : public EthPacket
{
    public:
        explicit IPPacket(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data);
        virtual ~IPPacket();
        void init(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data);
        int const IPhdrLen() const;
        std::string const * SrcIPaddr() const;
        std::string const * DstIPaddr() const;
        int const IPlen() const;
        int const TTL() const;
    protected:
        IPPacket();
        void init();
    private:
        std::string SourceIPaddr;
        std::string DestinationIPaddr;
        int IPheaderLen;
        int IPlength;
        int TTLvalue;
};

#endif // IPPACKET_H
