#include "packet.h"

// Constructor
Packet::Packet()
{
    this->init();
}

Packet::Packet(const struct pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data)
{
    this->init(Pkt_Hdr, Pkt_Data);
}

Packet::Packet(const long &TSsec, const long &TSmsec, const int &CapLength, const int &Length)
{
    this->init(TSsec, TSmsec, CapLength, Length);
}

// Desctructor
Packet::~Packet()
{

}

void Packet::init()
{
    this->setProto(PKT_PTC_NON_ETHERNET);
}

void Packet::init(const struct pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data)
{
    this->init();
    this->TimeStampSeconds = long(Pkt_Hdr->ts.tv_sec);
    this->TimeStampMicroSec = long(Pkt_Hdr->ts.tv_usec);
    this->CapturedLength = int(Pkt_Hdr->caplen);
    this->PacketLength = int(Pkt_Hdr->len);
}

void Packet::init(const long &TSsec, const long &TSmsec, const int &CapLength, const int &Length)
{
    this->init();
    this->TimeStampSeconds = TSsec;
    this->TimeStampMicroSec = TSmsec;
    this->CapturedLength = CapLength;
    this->PacketLength = Length;
}

void Packet::setProto(const int &Protocol)
{
    this->Proto = Protocol;
}

int const Packet::Protocol() const
{
    return this->Proto;
}

long const Packet::TSseconds() const
{
    return this->TimeStampSeconds;
}

long const Packet::TSmicrosec() const
{
    return this->TimeStampMicroSec ;
}

int const Packet::CapLen() const
{
    return this->CapturedLength;
}

int const Packet::Len() const
{
    return this->PacketLength;
}
