#ifndef PACKET_H
#define PACKET_H

#ifdef __cplusplus
extern "C"
{
#endif
#include <pcap.h>
#include <net/ethernet.h>
#include <netinet/ether.h>
#include <stdlib.h>
#ifdef __cplusplus
}
#endif

#include <string>

#ifndef PKT_PTC
#define PKT_PTC
#define PKT_PTC_NON_ETHERNET 0
#define PKT_PTC_ETHERNET 1
#define PKT_PTC_IP 2
#define PKT_PTC_TCP 3
#define PKT_PTC_UDP 4
#endif

class Packet
{
    public:
        explicit Packet(const struct pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data);
        explicit Packet(const long &TSsec, const long &TSmsec, const int &CapLength, const int &Length);
      //  Packet(Packet const& Pkt);
        virtual ~Packet();
        int const Protocol() const;
        long const TSseconds() const;
        long const TSmicrosec() const;
        int const CapLen() const;
        int const Len() const;
        void init(const struct pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data);
        void init(const long &TSsec, const long &TSmsec, const int &CapLength, const int &Length);
    protected:
        Packet();
        void init();
        void setProto(const int &Protocol);
    private:
        long TimeStampSeconds;
        long TimeStampMicroSec;
        int CapturedLength;
        int PacketLength;
        int Proto;
};

#endif // PACKET_H
