#ifndef PACKETSOURCE_H
#define PACKETSOURCE_H

#ifdef __cplusplus
extern "C"
{
#endif
#include <pcap.h>
#include <stdlib.h>
#ifdef __cplusplus
}
#endif

#include <packet.h>
#include <ethpacket.h>
#include <ippacket.h>
#include <tcppacket.h>
#include <udppacket.h>
#include <pcapexception.h>
#include <device.h>
#include <string>
#include <vector>
#include <cstring>

class PacketSource
{
    public:
        PacketSource();
        virtual ~PacketSource();

        void OpenOfflineSource(const char *FileName);
        void OpenOnlineSource(const char *device, const int &MaxSize, const int &Timeout);
        void CloseSource();

        Packet * NextPacket();
        bool IsOpen() const;
        std::string DeviceDesc(std::string Device);
        std::vector<Device> GetDeviceList();
    protected:
    private:
        pcap_t *PacketSrc;
};

#endif // PACKETSOURCE_H
