#include "tcppacket.h"

TCPPacket::TCPPacket()
{
    this->init();
}

TCPPacket::TCPPacket(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data)
{
    this->init(Pkt_Hdr, Pkt_Data);
}

TCPPacket::~TCPPacket()
{
    //dtor
}

void TCPPacket::init()
{
    IPPacket::init();
    this->setProto(PKT_PTC_TCP);
}

void TCPPacket::init(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data)
{
    IPPacket::init(Pkt_Hdr, Pkt_Data);
    struct tcphdr * tcp_hdr = (struct tcphdr *) (Pkt_Data + ETHER_HDRLEN + (this->IPhdrLen()));
    this->setProto(PKT_PTC_TCP);

    this->hdrLen = (tcp_hdr->doff) * 4;

    this->SourcePort = ntohs(tcp_hdr->source);
    this->DestinationPort = ntohs(tcp_hdr->dest);

    this->urgFlag = tcp_hdr->urg;
    this->ackFlag = tcp_hdr->ack;
    this->pshFlag = tcp_hdr->psh;
    this->rstFlag = tcp_hdr->rst;
    this->synFlag = tcp_hdr->syn;
    this->finFlag = tcp_hdr->fin;
}

bool const TCPPacket::Urg() const
{
    return this->urgFlag;
}

bool const TCPPacket::Ack() const
{
    return this->ackFlag;
}

bool const TCPPacket::Psh() const
{
    return this->pshFlag;
}

bool const TCPPacket::Rst() const
{
    return this->rstFlag;
}

bool const TCPPacket::Syn() const
{
    return this->synFlag;
}

bool const TCPPacket::Fin() const
{
    return this->finFlag;
}

int const TCPPacket::SrcPort() const
{
    return this->SourcePort;
}

int const TCPPacket::DstPort() const
{
    return this->DestinationPort;
}

int const TCPPacket::TcpHdrLen() const
{
	return this->hdrLen;
}

int const TCPPacket::TcpPayloadLen() const
{
	return this->IPlen() - (this->IPhdrLen() + this->hdrLen);
}
