#ifndef TCPPACKET_H
#define TCPPACKET_H

#ifdef __cplusplus
extern "C"
{
#endif
#include <netinet/tcp.h>
#ifdef __cplusplus
}
#endif

#include <ippacket.h>

class TCPPacket : public IPPacket
{
    public:
        explicit TCPPacket(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data);
        virtual ~TCPPacket();
        int const SrcPort() const;
        int const DstPort() const;
        void init(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data);
        bool const Urg() const;
        bool const Ack() const;
        bool const Psh() const;
        bool const Rst() const;
        bool const Syn() const;
        bool const Fin() const;
        int const TcpHdrLen() const;
        int const TcpPayloadLen() const;
    protected:
        TCPPacket();
        void init();
    private:
        int SourcePort;
        int DestinationPort;
        bool urgFlag;
        bool ackFlag;
        bool pshFlag;
        bool rstFlag;
        bool synFlag;
        bool finFlag;
        int hdrLen;
};

#endif // TCPPACKET_H
