#include "udppacket.h"

// contructor
UDPPacket::UDPPacket()
{
    this->init();
}

UDPPacket::UDPPacket(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data)
{
    this->init(Pkt_Hdr, Pkt_Data);
}

// destructor
UDPPacket::~UDPPacket()
{

}

void UDPPacket::init()
{
    IPPacket::init();
    this->setProto(PKT_PTC_UDP);
}

void UDPPacket::init(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data)
{
    IPPacket::init(Pkt_Hdr, Pkt_Data);
    struct udphdr * udp_hdr= (struct udphdr *) (Pkt_Data + ETHER_HDRLEN + this->IPhdrLen());
    this->setProto(PKT_PTC_UDP);

    this->SourcePort = ntohs(udp_hdr->source);
    this->DestinationPort = ntohs(udp_hdr->dest);
    this->UdpLen = ntohs(udp_hdr->len);
}

int const UDPPacket::SrcPort() const
{
    return this->SourcePort;
}

int const UDPPacket::DstPort() const
{
    return this->DestinationPort;
}

int const UDPPacket::UdpPayloadLen() const
{
	return this->UdpLen - UDP_HDRLEN;
}
