#ifndef UDPPACKET_H
#define UDPPACKET_H

#ifdef __cplusplus
extern "C"
{
#endif
#include <netinet/udp.h>
#ifdef __cplusplus
}
#endif

#include <ippacket.h>

#ifndef UDP_HDRLEN
#define UDP_HDRLEN 8
#endif

class UDPPacket : public IPPacket
{
    public:
        explicit UDPPacket(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data);
        virtual ~UDPPacket();
        int const SrcPort() const;
        int const DstPort() const;
        void init(const pcap_pkthdr *&Pkt_Hdr, const u_char *&Pkt_Data);
        int const UdpPayloadLen() const;
    protected:
        UDPPacket();
        void init();
    private:
        int SourcePort;
        int DestinationPort;
        int UdpLen;
};

#endif // UDPPACKET_H
