/*
 * \author João V. Gomes
 *
 *  slidingwindow.h
 *
 *  Created on: Oct 21, 2010
 *
 * \brief TODO
 * TODO
 */

#ifndef SLIDINGWINDOW_H_
#define SLIDINGWINDOW_H_

#ifdef __cplusplus
extern "C"
{
#endif
#include <math.h>
#ifdef __cplusplus
}
#endif

#include <deque>
#include <map>
#include <string>

#include <iostream>

template<class V> class SlidingWindow {
public:
	SlidingWindow(const int &WinSize);
	virtual ~SlidingWindow();
    void Clear();
	void AddElement(const V &Elem);
    const int WinSize() const;
    const int WinCount() const;
    const bool IsFilled() const;
    const int Count(const V &Elem);
    const V NewestElem() const;
    const V OldestElem() const;
    const V Min() const;
    const V Max() const;
    const double Mean() const;

private:
	SlidingWindow();
    void dispose();
    void init(const int &WinSize);
    V FindMin();
    V FindMax();
    void UpdateLimitsAdding(const V &Elem);
    void UpdateLimitsRemoving(const V &Elem);
	void RemoveElement();
	void InsertElement(const V &Elem);

	const typename std::deque<V>::iterator itToBegin();
	const typename std::deque<V>::iterator itToEnd();
    V max;
    V min;
    int WindowSize;
    std::map<V,int> Occurrences;
    std::deque<V> Window;
    double ValMean;
};

#endif /* SLIDINGWINDOW_H_ */
