/*
 * \author João V. Gomes
 *
 *  sortableslidingwindow.h
 *
 *  Created on: Oct 22, 2010
 *
 * \brief TODO
 * TODO
 */

#ifndef SORTABLESLIDINGWINDOW_H_
#define SORTABLESLIDINGWINDOW_H_

#include "slidingwindow.h"

template<class V> class SortableSlidingWindow: public SlidingWindow<V> {
public:
	SortableSlidingWindow(const int &WindowSize);
	virtual ~SortableSlidingWindow();
    void Clear();
	void AddElement(const V &Elem);
    const V Min() const;
    const V Max() const;
private:
	SortableSlidingWindow();
	void init(const int &WindowSize);
    V FindMin();
    V FindMax();
    void UpdateLimitsAdding(const V &Elem);
    void UpdateLimitsRemoving(const V &Elem);
	void RemoveElement();

    V max;
    V min;
};

#endif /* SORTABLESLIDINGWINDOW_H_ */
