/*
 * \author João V. Gomes
 *
 *  thresholdsset.cpp
 *
 *  Created on: Jun 24, 2010
 *
 * \brief TODO
 * TODO
 */

#include "thresholdsset.h"

ThresholdsSet::ThresholdsSet() {

}

ThresholdsSet::~ThresholdsSet() {

}

void ThresholdsSet::Clear()
{
	this->Thresholds.clear();
}

void ThresholdsSet::dispose()
{
	this->Clear();
}

void ThresholdsSet::AddThreshold(const double &MinValue, const std::string &Description)
{
	if (this->Thresholds.count(MinValue) == 0)
		this->Thresholds.insert(std::pair<double, std::string>(MinValue, Description));
	else
		this->Thresholds[MinValue] = Description;
}

const std::string ThresholdsSet::GetDescription(const double &Value)
{
	std::map<double, std::string>::reverse_iterator rit;

	for (rit = this->Thresholds.rbegin(); rit != this->Thresholds.rend(); rit++)
		if ( Value >= rit->first )
			return rit->second;

	return "";
}

void ThresholdsSet::PrintThresholds()
{
	std::map<double, std::string>::reverse_iterator rit;

	for (rit = this->Thresholds.rbegin(); rit != this->Thresholds.rend(); rit++)
		std::cout << rit->first << " - " << rit->second << std::endl;
}
