/*
 * \author João V. Gomes
 *
 *  variancecontainer.h
 *
 *  Created on: Oct 21, 2010
 *
 * \brief TODO
 * TODO
 */

#ifndef VARIANCECONTAINER_H_
#define VARIANCECONTAINER_H_

#ifdef __cplusplus
extern "C"
{
#endif
#include <math.h>
#ifdef __cplusplus
}
#endif

#include <slidingwindow.h>

#include <deque>
#include <map>
#include <string>

template<class V> class VarianceContainer {
    public:
		VarianceContainer();
		VarianceContainer(const int &WinSize);
        virtual ~VarianceContainer();
        double VarianceVal() const;
        double MeanVal() const;
        void AddValue(const V &value);
        int const WinSize() const;
        void Clear();
        long const TotalAnalyzedItems() const;
        V Min() const;
        V Max() const;
    protected:
    private:
        void init(const int &WinSize);
        void UpdateMean();
        void dispose();
        V FindMin() const;
        V FindMax() const;
        void UpdateLimits(const V &Value);

        long total;
        long WindowSize;
        V max;
        V min;
        long double CurrentVariance;
        long double CurrentMean;
        std::map<V,int> Occurrences;
        std::deque<V> Window;
};

#endif /* VARIANCECONTAINER_H_ */
