/*
 * \author João V. Gomes
 *
 *  main.cpp
 *
 *  Created on: Dec 28, 2010
 *
 * \brief TODO
 * TODO
 */

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <typeinfo>

#include <packetprocessor.h>
#include <pcapwrap.h>
#include <Folder.h>

using namespace std;

int main()
{
	// --- Parameters setup ---

	// Window size
	int const iWinSize = 25;

	// Use the frame length or the transport payload length
	const bool OnlyPLlength = true;

	// Filtering options
	const bool F_TCPNoPayload = false;
	const bool F_NoTCP = false;
	const bool F_NoAcks = false;
	const bool F_NoSyns = false;
	const bool F_NoLess65 = false;
	const bool F_TCPNoPLLess5 = false;
	const bool F_NoPLLess5 = true;

	// Operations
	const bool O_AnHosts = true;
	const bool O_ClHosts = false;
	const bool O_AnHostsPorts = false;
	const bool O_ClHostsPorts = false;
	const bool O_AnFlows = false;
	const bool O_ClFlows = false;

	// Extended Operations
	const bool O_AnHEx = false;
	const bool O_AnHPEx = false;
	const bool O_AnTupEx = false;
	const bool O_AnFlEx = false;

	// Features to be analyzed
	const bool An_PcktSize = true;
	const bool An_IPPort = false;
	const bool An_IATime = false;
	const int IAT_Precision = 1;

	// Directions
	const bool D_All = true;
	const bool D_In  = false;
	const bool D_Out = false;

	// Segmentation
	const bool bSegmentation = false;
	const int iSegmentionBase = 200;

	// Output
	const bool PrintSummary = false;
	const bool PrintLogs = true;

	const std::string IPaddress = "192.168.2.3";
	const std::string SubnetMask = "255.255.255.255";

	// --- Data processing ---

	stringstream ss;
	ss << iWinSize;

	vector<string> file_names;
	int i;

//	string const sBasePath = "/home/gomes";
	string const sBasePath = "/home/joao";
//	string const sBasePath = "/media/38b7bcfa-02d8-45b7-8fd1-5b588faf09a8";

//	string const outRootPath = sBasePath + "/Research/Documents/TraceAnalysis/Study_FileSharing/HostPort/NEW/";
//	string const outRootPath = sBasePath + "/Research/Documents/TraceAnalysis/Study_IEEE_Network/NonP2PApps/FrameLen/NoSegmentation/";
//	string const outRootPath = sBasePath + "/Research/Documents/TraceAnalysis/Study_IEEE_Network/NonP2PApps/FrameLen/Segmentation-200/";
//	string const outRootPath = sBasePath + "/Research/Documents/TraceAnalysis/Study_IEEE_Network/NoSegmentation/";
//	string const outRootPath = sBasePath + "/Research/Documents/TraceAnalysis/Study_IEEE_Network/Segmentation-200/";
//	string const outRootPath = "/media/iomega/BACKUP/ORI/Research/Documents/TraceAnalysis/Study_IEEE_Network/NonP2PApps/FrameLen/Segmentation-200/";

	string const outRootPath = sBasePath + "/Research/Documents/TraceAnalysis/Study_VoIP/windowSizeStudy/";


//	string const inRootPath = sBasePath + "/Research/Documents/Traces/SeveralNonP2PApps/";

//	file_names.push_back("09052011_1_CLEAN"); // 192.168.2.5
//	file_names.push_back("09052011_2_CLEAN"); // 192.168.2.5
//
//	file_names.push_back("20052011_1_CLEAN"); // 192.168.2.2
//	file_names.push_back("21052011_1_CLEAN"); // 192.168.2.2
//
//	file_names.push_back("29052011_1_CLEAN"); // 192.168.2.2
//	file_names.push_back("29052011_2_CLEAN"); // 192.168.2.2
//
//	file_names.push_back("03062011_1_CLEAN"); // 192.168.2.2
//	file_names.push_back("03062011_2_CLEAN"); // 192.168.2.2
//
//	file_names.push_back("labredes_25052011_pc1_1_CLEAN"); // 10.0.2.191
//	file_names.push_back("labredes_26052011_pc1_1_CLEAN"); // 10.0.2.191
//	file_names.push_back("labredes_25052011_pc1_2_CLEAN"); // 10.0.2.191
//
//	file_names.push_back("labredes_25052011_pc2_1_CLEAN"); // 10.0.2.126
//
//	file_names.push_back("labredes_26052011_pc2_1_CLEAN"); // 10.0.2.147
//
//	file_names.push_back("labredes_25052011_pc3_1_CLEAN"); // 10.0.2.159
//	file_names.push_back("labredes_26052011_pc3_1_CLEAN"); // 10.0.2.159
//
//	file_names.push_back("labredes_25052011_pc4_1_CLEAN"); // 10.0.2.172
//
//	file_names.push_back("labredes_26052011_pc4_1_CLEAN"); // 10.0.2.114
//
//	file_names.push_back("labredes_25052011_pc13_1_CLEAN"); // 10.0.2.115
//
//	file_names.push_back("labredes_26052011_pc13_1_CLEAN"); // 10.0.2.110
//
//	file_names.push_back("labredes_25052011_pc15_1_CLEAN"); // 10.0.2.158
//	file_names.push_back("labredes_26052011_pc15_1_CLEAN"); // 10.0.2.158


//	file_names.push_back("web_browsing_29052011_1_CLEAN"); // 192.168.2.2
//	file_names.push_back("web_browsing_03062011_1_CLEAN"); // 192.168.2.2

//	-----------------------------------------

//	string const inRootPath = sBasePath + "/Research/Documents/Traces/Traces_2011_1/";

//	file_names.push_back("amule_pc02_22062011_1_CLEAN"); // 10.0.2.102
//	file_names.push_back("amule_pc02_24062011_1_CLEAN"); // 10.0.2.102
//	file_names.push_back("amule_pc02_24062011_2_CLEAN"); // 10.0.2.102

//	file_names.push_back("audio_ondemand_HTTP_pc08_24062011_1_CLEAN"); // 10.0.2.140
//	file_names.push_back("audio_ondemand_RTSP_pc08_24062011_1_CLEAN"); // 10.0.2.140
//	file_names.push_back("audio_ondemand_RTSP_pc08_24062011_2_CLEAN"); // 10.0.2.140
//	file_names.push_back("video_ondemand_RTSP_pc08_24062011_1_CLEAN"); // 10.0.2.140
//
//	file_names.push_back("frostwire_pc15_22062011_1_CLEAN"); // 10.0.2.125
//	file_names.push_back("frostwire_pc15_24062011_1_CLEAN"); // 10.0.2.125
//	file_names.push_back("frostwire_pc15_24062011_2_CLEAN"); // 10.0.2.125
//
//	file_names.push_back("live_audio_Flash_pc07_24062011_1_CLEAN"); // 10.0.2.128
//	file_names.push_back("live_audio_Flash_pc07_24062011_2_CLEAN"); // 10.0.2.128
//
//	file_names.push_back("live_audio_MMS_pc05_24062011_1_CLEAN"); // 10.0.2.130
//	file_names.push_back("live_audio_MMS_pc05_24062011_2_CLEAN"); // 10.0.2.130
//	file_names.push_back("live_audio_streaming_MMS_pc05_22062011_1_CLEAN"); // 10.0.2.130
//
//	file_names.push_back("live_video_Flash_pc06_24062011_1_CLEAN"); // 10.0.2.193
//	file_names.push_back("live_video_RTSP_pc06_22062011_1_CLEAN"); // 10.0.2.193
//	file_names.push_back("live_video_RTSP_pc06_24062011_1_CLEAN"); // 10.0.2.193
//
//	file_names.push_back("ppstream_pc19_22062011_1_CLEAN"); // 10.0.2.171
//	file_names.push_back("ppstream_pc19_24062011_1_CLEAN"); // 10.0.2.171
//	file_names.push_back("ppstream_pc19_24062011_2_CLEAN"); // 10.0.2.171
//
//	file_names.push_back("sopcast_pc17_24062011_2_CLEAN"); // 10.0.2.162
//
//	file_names.push_back("sopcast_pc18_22062011_1_CLEAN"); // 10.0.2.157
//	file_names.push_back("tvu_pc18_24062011_1_CLEAN"); // 10.0.2.157
//	file_names.push_back("tvu_pc18_24062011_2_CLEAN"); // 10.0.2.157
//
//	file_names.push_back("torrent_28062011_1_CLEAN"); // 192.168.2.2

//	file_names.push_back("imap_20092011_1_CLEAN"); // 192.168.2.2
//	file_names.push_back("imap_19092011_1_CLEAN"); // 192.168.229.40
//	file_names.push_back("imap_19092011_2_CLEAN"); // 192.168.229.40

//	-----------------------------------------

//	string const inRootPath = sBasePath + "/Research/Documents/Traces/Traces_2010_1/";

//	192.168.2.6
//	file_names.push_back("amule_29082010_1_CLEAN1");
//	file_names.push_back("audio_streaming_on_demand_HTTP_29082010_1_CLEAN");
//	file_names.push_back("audio_streaming_on_demand_RTSP_29082010_1_CLEAN1");
//	file_names.push_back("controlled_trace_23092010_1_CLEAN");

//	192.168.2.4
//	file_names.push_back("controlled_trace_23092010_2_CLEAN");
//	file_names.push_back("ppstream_19082010_1_CLEAN1");
//	file_names.push_back("ppstream_23082010_1_CLEAN1");
//	file_names.push_back("tvu_12092010_CLEAN");

//	192.168.228.187
//	file_names.push_back("http_download_25082010_1_1_CLEAN");
//	file_names.push_back("web_browsing_25082010_1_CLEAN");

//	192.168.2.2
//	file_names.push_back("live_audio_streaming_RTSP_rai_06092010_1_CLEAN");
//	file_names.push_back("video_ondemand_flash_rtp_06092010_1_FULL_CLEAN");
//	file_names.push_back("youtube_06092010_1_FULL_CLEAN_PART1");

//	192.168.2.3
//	file_names.push_back("audio_streaming_on_demand_Flash_24082010_1_CLEAN");
//	file_names.push_back("audio_streaming_on_demand_HTTP_13092010_1_CLEAN");
//	file_names.push_back("audio_streaming_on_demand_HTTP_13092010_2_CLEAN");
//	file_names.push_back("audio_streaming_on_demand_RTSP_13092010_1_CLEAN");
//	file_names.push_back("controlled_trace_16082010_1_CLEAN");
//	file_names.push_back("controlled_trace_16082010_2_CLEAN");
//	file_names.push_back("controlled_trace_24092010_1_CLEAN");
//	file_names.push_back("controlled_trace_24092010_2_CLEAN");
//	file_names.push_back("controlled_trace_25092010_1_CLEAN");
//	file_names.push_back("dailymotion_16082010_1_CLEAN1");
//	file_names.push_back("ftp_24082010_1_2");
//	file_names.push_back("googletalk_VoIP_16082010_1_CLEAN");
//	file_names.push_back("lime_wire_16082010_1_CLEAN1");
//	file_names.push_back("lime_wire_29072010_1_CLEAN");
//	file_names.push_back("live_audio_flash_12092010_1_CLEAN");
//	file_names.push_back("live_audio_streaming_Flash_24082010_1_CLEAN");
//	file_names.push_back("live_audio_streaming_MMS_04092010_1_FULL_CLEAN");
//	file_names.push_back("live_audio_streaming_MMS_12092010_1_CLEAN");
//	file_names.push_back("live_audio_streaming_MMS_13092010_1_CLEAN");
//	file_names.push_back("live_audio_streaming_MMS_20082010_1_CLEAN");
//	file_names.push_back("live_audio_streaming_MMS_21072010_1_CLEAN");
//	file_names.push_back("live_audio_streaming_RTSP_12092010_1_CLEAN");
//	file_names.push_back("live_audio_streaming_RTSP_13092010_1_CLEAN");
//	file_names.push_back("live_audio_streaming_RTSP_17082010_1_CLEAN");
//	file_names.push_back("live_video_streaming_Flash_12092010_1_CLEAN");
//	file_names.push_back("live_video_streaming_Flash_13092010_1_CLEAN");
//	file_names.push_back("live_video_streaming_Flash_13092010_2_CLEAN");
//	file_names.push_back("live_video_streaming_Flash_23082010_1_CLEAN");
//	file_names.push_back("live_video_streaming_MMS_23082010_1_CLEAN1");
//	file_names.push_back("live_video_streaming_RTSP_23082010_1_CLEAN1");
//	file_names.push_back("sftp_04092010_1_CLEAN");
//	file_names.push_back("skype_voip_30072010_1_CLEAN1");
//	file_names.push_back("sopcast_16082010_1_CLEAN1");
//	file_names.push_back("sopcast_23082010_1_CLEAN1");
//	file_names.push_back("ssh_04092010_1_CLEAN");
//	file_names.push_back("telnet_24082010_1_CLEAN");
//	file_names.push_back("torrent_23082010_1_CLEAN1");
//	file_names.push_back("video_ondemand_flash_rtp_04092010_1_CLEAN");
//	file_names.push_back("video_streaming_ondemand_HTTP_13092010_1_CLEAN");
//	file_names.push_back("video_streaming_ondemand_HTTP_13092010_2_CLEAN");
//	file_names.push_back("video_streaming_ondemand_RTSP_13092010_1_CLEAN");
//	file_names.push_back("video_streaming_ondemand_RTSP_13092010_2_CLEAN");
//	file_names.push_back("video_streaming_ondemand_RTSP_23082010_1_CLEAN");
//	file_names.push_back("youtube_04092010_1_CLEAN");
//	file_names.push_back("youtube_21072010_1_CLEAN1");


//	string const inRootPath = sBasePath + "/Research/Documents/Traces/traces12-11-2006_IP84-90-34-206/";
//	file_names.push_back("download_emule_12112006_1_CLEAN");
//	file_names.push_back("google_voip_12112006_1_CLEAN");
//	file_names.push_back("msn_voip_12112006_1_CLEAN");
//	file_names.push_back("skype_voip_12112006_1_CLEAN");
//	file_names.push_back("upload_emule_12112006_1_CLEAN");


//	string const inRootPath = sBasePath + "/Research/Documents/Traces/traces24-10-2006_IP192-168-2-109/";
//	file_names.push_back("emule_download_24102006_1_CLEAN");
//	file_names.push_back("http_download_24102006_1_CLEAN");
//	file_names.push_back("msn_voip_24102006_1_CLEAN");
//	file_names.push_back("skype_voip_24102006_1_CLEAN");
//	file_names.push_back("web_browsing_24102006_1_CLEAN");


//	string const inRootPath = sBasePath + "/Research/Documents/Traces/traces30-10-2006_IP192-168-2-109/";
//	file_names.push_back("bittorrent_download_30102006_1_CLEAN");
//	file_names.push_back("email_POP_30102006_1_CLEAN");
//	file_names.push_back("email_SMTP_30102006_1_CLEAN");
//	file_names.push_back("emule_30102006_1_CLEAN");
//	file_names.push_back("emule_upload_30102006_1_CLEAN");
//	file_names.push_back("http_download_30102006_1_CLEAN");
//	file_names.push_back("http_download_30102006_2_CLEAN");
//	file_names.push_back("http_download_30102006_3_CLEAN");
//	file_names.push_back("live_audio_streaming_MMS_30102006_1_CLEAN");
//	file_names.push_back("video_streaming_ondemand_RTSP_30102006_1_CLEAN");


//	string const inRootPath = sBasePath + "/Research/Documents/Traces/traces_UNIBS/";
//	file_names.push_back("unibs20090930.anon");
//	file_names.push_back("unibs20091001.anon");



// ------ VoIP TRACES ------- //

//	string const inRootPath = sBasePath + "/joao/Research/Documents/Traces/Traces_Polito/Skype_E2E_Traces/"; // 128.0.0.1
//	file_names.push_back("skype_call_110108_SVOPC.dump.anonim");
//	file_names.push_back("skype_call_140606_UDP_EG711A.dump.anonim");
//	file_names.push_back("skype_call_140606_UDP_EG711U.dump.anonim");
//	file_names.push_back("skype_call_140606_UDP_G729.dump.anonim");
//	file_names.push_back("skype_call_140606_UDP_iLBC.dump.anonim");
//	file_names.push_back("skype_call_140606_UDP_IPCMWB.dump.anonim");
//	file_names.push_back("skype_call_140606_UDP_PCMA.dump.anonim");
//	file_names.push_back("skype_call_140606_UDP_PCMU.dump.anonim");
//	file_names.push_back("skype_call_250906_TCP_ISAC.dump.anonim");
//	file_names.push_back("skype_call_260606_UDP_ISAC.dump.anonim");

//	string const inRootPath = sBasePath + "/joao/Research/Documents/Traces/Traces_2010_1/"; // 192.168.2.3
//	file_names.push_back("googletalk_VoIP_16082010_1_CLEAN");
//	file_names.push_back("skype_voip_30072010_1_CLEAN1");

//	string const inRootPath = sBasePath + "/joao/Research/Documents/Traces/traces12-11-2006_IP84-90-34-206/"; // 84.90.34.206
//	file_names.push_back("google_voip_12112006_1_CLEAN");
//	file_names.push_back("msn_voip_12112006_1_CLEAN");
//	file_names.push_back("skype_voip_12112006_1_CLEAN");

//	string const inRootPath = sBasePath + "/joao/Research/Documents/Traces/traces24-10-2006_IP192-168-2-109/"; // 192.168.2.109
//	file_names.push_back("msn_voip_24102006_1_CLEAN");
//	file_names.push_back("skype_voip_24102006_1_CLEAN");

//	string const inRootPath = sBasePath + "/joao/Research/Documents/Traces/Traces_VoIP_2010/192.168.2.2/"; // 192.168.2.2
//	file_names.push_back("sip_Lw-Ll_silence_SPEEX16_UDP_27012011_1_CLEAN");
//	file_names.push_back("sip_Lw-Ll_silence_SPEEX16_UDP_27012011_2_CLEAN");
//	file_names.push_back("sip_Lw-Ll_silence_SPEEX32_UDP_27012011_1_CLEAN");
//	file_names.push_back("sip_Lw-Ll_silence_SPEEX32_UDP_27012011_2_CLEAN");
//	file_names.push_back("sip_Lw-Ll_silence_SPEEX8_UDP_27012011_1_CLEAN");
//	file_names.push_back("sip_Lw-Ll_silence_SPEEX8_UDP_27012011_2_CLEAN");
//	file_names.push_back("sip_Lw-Ll_SPEEX16_UDP_27012011_1_CLEAN");
//	file_names.push_back("sip_Lw-Ll_SPEEX32_UDP_27012011_1_CLEAN");
//	file_names.push_back("sip_Lw-Ll_SPEEX8_UDP_27012011_1_CLEAN");
//	file_names.push_back("sip_Lw-Ll_voice_SPEEX16_UDP_27012011_1_CLEAN");
//	file_names.push_back("sip_Lw-Ll_voice_SPEEX32_UDP_27012011_1_CLEAN");
//	file_names.push_back("sip_Lw-Ll_voice_SPEEX8_UDP_27012011_1_CLEAN");
//	file_names.push_back("sip_Lw-Lw_silence_SPEEX16_UDP_27012011_1_CLEAN");
//	file_names.push_back("sip_Lw-Lw_voice_SPEEX32_UDP_27012011_1_CLEAN");
//	file_names.push_back("skype_EG711A_UDP_13122010_1_CLEAN");
//	file_names.push_back("skype_EG711U_UDP_13122010_1_CLEAN");
//	file_names.push_back("skype_G729_UDP_13122010_2_CLEAN");
//	file_names.push_back("skype_ILBC_UDP_13122010_1_CLEAN");
//	file_names.push_back("skype_ILBC_UDP_13122010_2_CLEAN");
//	file_names.push_back("skype_IPCMWB_UDP_13122010_1_CLEAN");
//	file_names.push_back("skype_IPCMWB_UDP_13122010_2_CLEAN");
//	file_names.push_back("skype_ISAC_UDP_13122010_1_CLEAN");
//	file_names.push_back("skype_PCMA_UDP_13122010_1_CLEAN");
//	file_names.push_back("skype_PCMU_UDP_13122010_1_CLEAN");
//	file_names.push_back("skype_PCMU_UDP_13122010_2_CLEAN");
//	file_names.push_back("skype_SILK_TCP_27012011_1_CLEAN");
//	file_names.push_back("skype_SILK_UDP_27012011_1_CLEAN");
//	file_names.push_back("skype_SILK_WB_TCP_27012011_1_CLEAN");
//	file_names.push_back("skype_SILK_WB_UDP_27012011_1_CLEAN");

	string const inRootPath = sBasePath + "/Research/Documents/Traces/Traces_VoIP_2010/192.168.2.3/";  // 192.168.2.3
//	file_names.push_back("sip_B-AL_GSM_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-AL_PCMU_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-AL_SPEEX16_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-AL_SPEEX8_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-B_G722_UDP_13012011_1_CLEAN");
//	file_names.push_back("sip_B-B_GSM_UDP_13012011_1_CLEAN");
//	file_names.push_back("sip_B-B_ILBC_UDP_13012011_1_CLEAN");
//	file_names.push_back("sip_B-B_PCMA_UDP_13012011_1_CLEAN");
//	file_names.push_back("sip_B-B_PCMA_UDP_13012011_2_CLEAN");
//	file_names.push_back("sip_B-B_PCMU_UDP_13012011_1_CLEAN");
//	file_names.push_back("sip_B-B_SPEEX16_UDP_13012011_1_CLEAN");
//	file_names.push_back("sip_B-B_SPEEX32_UDP_13012011_1_CLEAN");
//	file_names.push_back("sip_B-C_G722_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-C_GSM_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-C_ILBC_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-C_PCMA_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-C_PCMU_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-C_SPEEX32_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-C_SPEEX8_UDP_13012011_1_CLEAN");
//	file_names.push_back("sip_B-C_SPEEX8_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-X_GSM_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-X_ILBC_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-X_PCMA_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-X_PCMU_UDP_18012011_1_CLEAN");
//	file_names.push_back("sip_B-X_SPEEX8_UDP_18012011_1_CLEAN");
//	file_names.push_back("skype_A_G729_UDP_18012011_1_CLEAN");
//	file_names.push_back("skype_A_SILK_NB_V3_UDP_18012011_1_CLEAN");
//	file_names.push_back("skype_A_SILK_WB_V3_UDP_18012011_1_CLEAN");
//	file_names.push_back("skype_EG711A_TCP_16122010_1_CLEAN");
//	file_names.push_back("skype_EG711A_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_EG711A_UDP_16122010_1_CLEAN");
//	file_names.push_back("skype_EG711U_TCP_16122010_1_CLEAN");
//	file_names.push_back("skype_EG711U_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_EG711U_UDP_16122010_1_CLEAN");
//	file_names.push_back("skype_G729_TCP_16122010_1_CLEAN");
//	file_names.push_back("skype_G729_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_G729_TCP_17122010_2_CLEAN");
//	file_names.push_back("skype_G729_TCP_21122010_1_CLEAN");
//	file_names.push_back("skype_G729_UDP_13122010_1_CLEAN");
//	file_names.push_back("skype_G729_UDP_21122010_1_CLEAN");
//	file_names.push_back("skype_G729_UDP_29112010_1_CLEAN");
//	file_names.push_back("skype_ILBC_TCP_16122010_1_CLEAN");
//	file_names.push_back("skype_ILBC_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_ILBC_UDP_16122010_1_CLEAN");
//	file_names.push_back("skype_IPCMWB_TCP_16122010_1_CLEAN");
//	file_names.push_back("skype_IPCMWB_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_IPCMWB_UDP_16122010_1_CLEAN");
//	file_names.push_back("skype_ISAC_TCP_16122010_1_CLEAN");
//	file_names.push_back("skype_ISAC_TCP_17122010_1_CLEAN");
	file_names.push_back("skype_ISAC_UDP_16122010_1_CLEAN");
//	file_names.push_back("skype_NWC_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_NWC_TCP_21122010_1_CLEAN");
//	file_names.push_back("skype_NWC_UDP_21122010_1_CLEAN");
//	file_names.push_back("skype_NWC_UDP_29112010_1_CLEAN");
//	file_names.push_back("skype_PCMA_TCP_16122010_1_CLEAN");
//	file_names.push_back("skype_PCMA_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_PCMA_TCP_17122010_2_CLEAN");
//	file_names.push_back("skype_PCMA_TCP_21122010_1_CLEAN");
//	file_names.push_back("skype_PCMA_UDP_16122010_1_CLEAN");
//	file_names.push_back("skype_PCMA_UDP_21122010_1_CLEAN");
//	file_names.push_back("skype_PCMA_UDP_29112010_1_CLEAN");
//	file_names.push_back("skype_PCMU_TCP_16122010_1_CLEAN");
//	file_names.push_back("skype_PCMU_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_PCMU_TCP_17122010_2_CLEAN");
//	file_names.push_back("skype_PCMU_TCP_21122010_1_CLEAN");
//	file_names.push_back("skype_PCMU_UDP_16122010_1_CLEAN");
//	file_names.push_back("skype_PCMU_UDP_21122010_1_CLEAN");
//	file_names.push_back("skype_PCMU_UDP_29112010_1_CLEAN");
//	file_names.push_back("skype_SILK_MB_V3_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_SILK_MB_V3_TCP_21122010_1_CLEAN");
//	file_names.push_back("skype_SILK_MB_V3_UDP_21122010_1_CLEAN");
//	file_names.push_back("skype_SILK_MB_V3_UDP_29112010_1_CLEAN");
//	file_names.push_back("skype_SILK_NB_V3_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_SILK_NB_V3_TCP_21122010_1_CLEAN");
//	file_names.push_back("skype_SILK_NB_V3_UDP_21122010_1_CLEAN");
//	file_names.push_back("skype_SILK_NB_V3_UDP_29112010_1_CLEAN");
//	file_names.push_back("skype_SILK_TCP_12012011_1_CLEAN");
//	file_names.push_back("skype_SILK_UDP_12012011_1_CLEAN");
//	file_names.push_back("skype_SILK_V3_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_SILK_V3_TCP_21122010_1_CLEAN");
//	file_names.push_back("skype_SILK_V3_UDP_21122010_1_CLEAN");
//	file_names.push_back("skype_SILK_V3_UDP_29112010_1_CLEAN");
//	file_names.push_back("skype_SILK_WB_TCP_12012011_1_CLEAN");
//	file_names.push_back("skype_SILK_WB_UDP_12012011_1_CLEAN");
//	file_names.push_back("skype_SILK_WB_V3_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_SILK_WB_V3_TCP_21122010_1_CLEAN");
//	file_names.push_back("skype_SILK_WB_V3_UDP_21122010_1_CLEAN");
//	file_names.push_back("skype_SILK_WB_V3_UDP_29112010_1_CLEAN");
//	file_names.push_back("skype_SVOPC_SB_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_SVOPC_SB_TCP_21122010_1_CLEAN");
//	file_names.push_back("skype_SVOPC_SB_UDP_21122010_1_CLEAN");
//	file_names.push_back("skype_SVOPC_SB_UDP_29112010_1_CLEAN");
//	file_names.push_back("skype_SVOPC_TCP_17122010_1_CLEAN");
//	file_names.push_back("skype_SVOPC_TCP_21122010_1_CLEAN");
	file_names.push_back("skype_SVOPC_UDP_21122010_1_CLEAN");
//	file_names.push_back("skype_SVOPC_UDP_29112010_1_CLEAN");

//	string const inRootPath = sBasePath + "/joao/Research/Documents/Traces/Traces_VoIP_2010/192.168.2.4/"; // 192.168.2.4
//	file_names.push_back("skype_EG711A_UDP_09122010_1_CLEAN");
//	file_names.push_back("skype_EG711U_UDP_09122010_1_CLEAN");
//	file_names.push_back("skype_G729_UDP_09122010_1_CLEAN");
//	file_names.push_back("skype_ILBC_UDP_09122010_1_CLEAN");
//	file_names.push_back("skype_IPCMWB_UDP_09122010_1_CLEAN");
//	file_names.push_back("skype_ISAC_UDP_09122010_1_CLEAN");
//	file_names.push_back("skype_PCMA_UDP_09122010_1_CLEAN");
//	file_names.push_back("skype_PCMU_UDP_09122010_1_CLEAN");

//	string const inRootPath = sBasePath + "/joao/Research/Documents/Traces/Traces_VoIP_2010/192.168.2.6/"; // 192.168.2.6
//	file_names.push_back("sip_Lw-Ll_SPEEX16_UDP_13032010_1_CLEAN");
//	file_names.push_back("sip_Lw-Ll_SPEEX32_UDP_13032010_1_CLEAN");
//	file_names.push_back("sip_Lw-Ll_SPEEX8_UDP_13032010_1_CLEAN");

//	string const inRootPath = sBasePath + "/Research/Documents/Traces/Traces_VoIP_2010/192.168.2.7/"; // 192.168.2.7
//	file_names.push_back("skype_AMRWB_TCP_03032011_1_CLEAN");
//	file_names.push_back("skype_AMRWB_TCP_03032011_2_CLEAN");
//	file_names.push_back("skype_AMRWB_UDP_03032011_1_CLEAN");
//	file_names.push_back("skype_AMRWB_UDP_03032011_2_CLEAN");
//	file_names.push_back("skype_ILBC_TCP_03032011_1_CLEAN");

	try
	{

		for (i = 0; i != file_names.size(); i++)
		{
			cout << endl << "---" << endl << "Processing file: " << file_names[i] << endl;

			cout << "\nCreating the set of thresholds...\n";
			ThresholdsSet TSet;

			TSet.AddThreshold(1.0, "P2P File-Sharing");
			TSet.AddThreshold(0, "Non-P2P");
			TSet.AddThreshold(3.5, "VoIP");
			cout << "DONE.\n";

			cout << "\nCreating PacketSource...\n";
			PacketSource PS;

			string const fileName = file_names[i];

			string outFilterPath = "";

			if (OnlyPLlength)
				outFilterPath += "PlLength/";
			else
				outFilterPath += "FrLength/";

			if (!(F_TCPNoPayload || F_NoTCP || F_NoAcks || F_NoLess65 || F_NoSyns || F_TCPNoPLLess5 || F_NoPLLess5))
				outFilterPath += "NoFilters/";
			else if (F_TCPNoPayload && !(F_NoTCP || F_NoAcks || F_NoLess65 || F_NoSyns || F_TCPNoPLLess5 || F_NoPLLess5))
				outFilterPath += "TCPNoPayload/";
			else if (F_NoTCP && !(F_TCPNoPayload || F_NoAcks || F_NoLess65 || F_NoSyns || F_TCPNoPLLess5 || F_NoPLLess5))
				outFilterPath += "NoTCP/";
			else if (F_NoAcks && !(F_TCPNoPayload || F_NoTCP || F_NoLess65 || F_NoSyns || F_TCPNoPLLess5 || F_NoPLLess5))
				outFilterPath += "Acks/";
			else if (F_NoLess65 && !(F_TCPNoPayload || F_NoTCP || F_NoAcks || F_NoSyns || F_TCPNoPLLess5 || F_NoPLLess5))
				outFilterPath += "NoLess65/";
			else if (F_TCPNoPLLess5 && !(F_TCPNoPayload || F_NoTCP || F_NoAcks || F_NoSyns || F_NoLess65 || F_NoPLLess5))
				outFilterPath += "TCPNoPLLess5/";
			else if (F_NoPLLess5 && !(F_TCPNoPayload || F_NoTCP || F_NoAcks || F_NoSyns || F_NoLess65 || F_TCPNoPLLess5))
				outFilterPath += "NoPLLess5/";

			string const WinPath = ss.str() + "PacketsWindow/";
			string const outBasePath = outRootPath + outFilterPath + fileName + "/" + WinPath;

			string const filePath = inRootPath + fileName + ".pcap";

			string const outHostsPath = outBasePath + "Entropy_Hosts/";
			string const outHostsClassificationPath = outBasePath + "/Entropy_HostsClassification";
			string const outHostsPortsPath = outBasePath + "/Entropy_HostsPorts";
			string const outHostsPortsClassificationPath = outBasePath + "/Entropy_HostsPortsClassification";
			string const outFlowsPath = outBasePath + "/Entropy_Flows";
			string const outFlowsClassificationPath = outBasePath + "/Entropy_FlowsClassification";

			string const outHostsExtendedPath = outBasePath + "/HostAnalysis";
			string const outHostPortsExtendedPath = outBasePath + "/HostPortAnalysis";
			string const outTuplesExtendedPath = outBasePath + "/TupleAnalysis";
			string const outFlowsExtendedPath = outBasePath + "/FlowAnalysis";

			string const compHostPortsExtendedPath = outFilterPath + fileName + "/" + WinPath + "/HostPortAnalysis";
			string const compFlowsExtendedPath = outFilterPath + fileName + "/" + WinPath + "/FlowAnalysis";


			try {
			PS.OpenOfflineSource(filePath.c_str());
			cout << "DONE.\n";

			cout << "\nCreating PacketProcessor...\n";

			PacketProcessor PP(&PS, OnlyPLlength, IPaddress, SubnetMask);

			// Segmentation
			PP.SetSegmentation(bSegmentation, iSegmentionBase);

			// Features to be analyzed
			if (An_PcktSize)
				PP.SetPropertiesToAnalyze(PACKET_SIZE);
			if (An_IATime)
				PP.SetPropertiesToAnalyze(INTER_ARRIVAL_TIME);
			if (An_IPPort)
				PP.SetPropertiesToAnalyze(IP_PORT);

			// Directions
			if (D_Out)
				PP.SetDirections(DIR_OUT);
			if (D_In)
				PP.SetDirections(DIR_IN);
			if (D_All)
				PP.SetDirections(DIR_ALL);

			// Filters
			if (F_TCPNoPayload)
				PP.SetFilters(NO_PAYLOAD);
			if (F_NoAcks)
				PP.SetFilters(ACK_PCKT);
			if (F_NoSyns)
				PP.SetFilters(SYN_PCKT);
			if (F_NoLess65)
				PP.SetFilters(NO_LESS_65);
			if (F_TCPNoPLLess5)
				PP.SetFilters(NO_TCP_PL_LESS_5);
			if (F_NoPLLess5)
				PP.SetFilters(NO_PL_LESS_5);
			if (F_NoTCP)
				PP.SetFilters(NO_TCP);

			cout << "DONE.\n";

			cout << "\nProcessing the packets...\n";
			if (O_AnHosts)
				PP.AnalyzeHosts(iWinSize, outHostsPath);
			if (O_ClHosts)
				PP.ClassifyHosts(iWinSize, outHostsClassificationPath, &TSet);
			if (O_AnHostsPorts)
				PP.AnalyzeHostsPorts(iWinSize, outHostsPortsPath);
			if (O_ClHostsPorts)
				PP.ClassifyHostsPorts(iWinSize, outHostsPortsClassificationPath, &TSet);
			if (O_AnFlows)
				PP.AnalyzeFlows(iWinSize, outFlowsPath);
			if (O_ClFlows)
				PP.ClassifyFlows(iWinSize, outFlowsClassificationPath, &TSet);

			if (O_AnHEx)
				PP.AnalyzeHostsExtended(iWinSize, IAT_Precision, outHostsExtendedPath);
			if (O_AnHPEx)
				PP.AnalyzeHostPortsExtended(iWinSize, IAT_Precision, outRootPath, compHostPortsExtendedPath, PrintSummary, PrintLogs);
			if (O_AnTupEx)
				PP.AnalyzeTuplesExtended(iWinSize, IAT_Precision, outTuplesExtendedPath);
			if (O_AnFlEx)
				PP.AnalyzeFlowsExtended(iWinSize, IAT_Precision, outRootPath, compFlowsExtendedPath, PrintSummary, PrintLogs);

			cout << "DONE.\n";

			PS.CloseSource();
			}
			catch (Dev_Open_Offline_Fail e1)
			{
				cout << "FFFFFailed to open the file: " << e1.what() << "\n";
			}
		}
	}
	catch (Src_Already_Open e)
	{
		cout << "This Object PacketSource already has an open source. Please close it first.\n";
	}
//	catch (Dev_Open_Offline_Fail e1)
//	{
//		cout << "Failed to open the file: " << e1.what() << "\n";
//	}
	catch (Dev_Open_Live_Fail e2)
	{
		cout << "Failed to open the device: " << e2.what() << "\n";
	}
	catch (Dev_Open_Live_Warning e3)
	{
		cout << "Warning: " << e3.what() << "\n";
	}
	catch (Timeout_Expired e4)
	{
		cout << "Timeout: " << e4.what() << "\n";
	}
	catch (No_More_Packets e5)
	{
		cout << "No more packets: " << e5.what() << "\n";
	}
	catch (Packet_Reading_Error e6)
	{
		cout << "Failed: " << e6.what() << "\n";
	}
	catch (Src_Not_Open e7)
	{
		cout << "The Packet Source is not open yet. Please provide an open source.\n";
	}
	catch (PSrc_Not_Open e8)
	{
		cout << "Packet Source failed: " << e8.what() << "\n";
	}

    return 0;
}
