#ifndef PPEXCEPTION_H_INCLUDED
#define PPEXCEPTION_H_INCLUDED

#include <stdexcept>
#include <string>

///
/// Generic PacketProcessor Exception.
///	Derives from std::runtime_error.
///
class PPException : public std::runtime_error
{
	public:

		PPException(std::string const& err_msg)
		:	std::runtime_error(err_msg)
		{ }

};

class PSrc_Not_Open : public PPException
{
    public:

        PSrc_Not_Open()
        :   PPException("The Packet Source is not open. Please provide an open source.")
        { }
};

#endif // PPEXCEPTION_H_INCLUDED
