/*
 * \author João V. Gomes
 *
 *  packetprocessor.h
 *
 *  Created on: Dec 28, 2010
 *
 * \brief TODO
 * TODO
 */

#ifndef PACKETPROCESSOR_H_
#define PACKETPROCESSOR_H_

#include <pcapwrap.h>
#include <Folder.h>
#include <trafficinspector.h>
#include <alarmraiser.h>
#include <ppexception.h>
#include <string>

#ifndef FILTERS
#define FILTERS
#define ACK_PCKT 0
#define SYN_PCKT 1
#define FULL_PCKT 2
#define NO_PAYLOAD 3
#define NO_TCP 3
#endif // FILTERS

class PacketProcessor {
public:
	PacketProcessor();
	PacketProcessor(PacketSource *PacketSrc);
	PacketProcessor(AlarmRaiser *ARaiser);
	PacketProcessor(PacketSource *PacketSrc, AlarmRaiser *ARaiser);
	virtual ~PacketProcessor();

	void FindVoIP(const int &WinSize);
	void OuputClassification(const int &WinSize);

	void CloseSource();
	void ResetPacketSource(PacketSource *PacketSrc);
	void ResetAlarmRaise(AlarmRaiser *ARaiser);
    void SetFilters(const int &Filter);
    void UnsetFilters(const int &Filter);

private:
	void init();
	void dispose();
	bool const FilterPacket(const Packet * Pckt) const;

	AlarmRaiser * ARaiser;
	PacketSource * PcktSrc;
    bool FilterAck;
    bool FilterSyn;
    bool FilterFull;
    bool FilterTCPnoPayload;
    bool FilterNoTCP;
};

#endif /* PACKETPROCESSOR_H_ */
