/*
 * \author João V. Gomes
 *
 *  packetprocessor.h
 *
 *  Created on: Dec 28, 2010
 *
 * \brief TODO
 * TODO
 */

#ifndef PACKETPROCESSOR_H_
#define PACKETPROCESSOR_H_

#include <pcapwrap.h>
#include <Folder.h>
#include <statisticalanalyzer.h>
#include <alarmraiser.h>
#include <ppexception.h>
#include <string>

#ifndef FILTERS
#define FILTERS
#define ACK_PCKT 0
#define SYN_PCKT 1
#define FULL_PCKT 2
#define NO_PAYLOAD 3
#define NO_TCP 4
#define NO_LESS_60 5
#define NO_LESS_65 6
#define NO_TCP_PL_LESS_5 7
#define NO_PL_LESS_5 8
#endif // FILTERS

class PacketProcessor {
public:
	PacketProcessor(PacketSource *PacketSrc, AlarmRaiser *ARaiser);
	PacketProcessor(PacketSource *PacketSrc, AlarmRaiser *ARaiser, const bool &OnlyPayloadLength, const bool &TuppleBased);
    void Clear();
	virtual ~PacketProcessor();

	void FindVoIP(const int &WinSize);
	void OuputClassification(const int &WinSize);

	void CloseSource();
	void ResetPacketSource(PacketSource *PacketSrc);
	void ResetAlarmRaise(AlarmRaiser *ARaiser);
    void SetFilters(const int &Filter);
    void UnsetFilters(const int &Filter);

private:
	void init(PacketSource *PacketSrc, AlarmRaiser *ARaiser, const bool &OnlyPayloadLength, const bool &TuppleBased);
	void dispose();
	bool const FilterPacket(const Packet * Pckt) const;

	AlarmRaiser * ARaiser;
	PacketSource * PcktSrc;
    bool FilterAck;
    bool FilterSyn;
    bool FilterFull;
    bool FilterTCPnoPayload;
    bool FilterNoTCP;
    bool FilterNoLess60;
    bool FilterNoLess65;
    bool FilterTCPPayloadLess5;
    bool FilterPayloadLess5;
    bool OnlyPayloadLen;
    bool TupBased;
};

#endif /* PACKETPROCESSOR_H_ */
