/*
 * \author João V. Gomes
 *
 *  tupple.cpp
 *
 *  Created on: Jan 5, 2011
 *
 * \brief TODO
 * TODO
 */

#include "tuple.h"

Tuple::Tuple() {

}

Tuple::Tuple(const std::string &Host1, const int &Port1, const std::string &Host2, const int &Port2, const int &Proto) {
	this->init(Host1, Port1, Host2, Port2, Proto);
}

Tuple::Tuple(const std::string &HostPort1, const std::string &HostPort2, const int &Proto) {
	this->init(HostPort1 + ":" + HostPort2 + ":" + this->PrototoString(Proto));
}

Tuple::Tuple(const std::string &Tup) {
	this->init(Tup);
}

Tuple::Tuple(const std::string &Host1, const std::string &Port1, const std::string &Host2, const std::string &Port2, const std::string &Proto) {
	this->init(Host1, Port1, Host2, Port2, Proto);
}

Tuple::~Tuple() {

}

void Tuple::init(const std::string &Tup) {
	int pos = Tup.find(":");
	this->HostSrc = Tup.substr(0, pos);
	std::string Remainder = Tup.substr(pos+1);
	pos = Remainder.find(":");
	this->PortSrc = atoi(Remainder.substr(0, pos).c_str());
	Remainder = Remainder.substr(pos+1);
	pos = Remainder.find(":");
	this->HostDst = Remainder.substr(0, pos);
	Remainder = Remainder.substr(pos+1);
	pos = Remainder.find(":");
	this->PortDst = atoi(Remainder.substr(0, pos).c_str());
	this->Protocol = this->PrototoInt(Remainder.substr(pos+1));
	this->GetString();
}

void Tuple::init(const std::string &Host1, const int &Port1, const std::string &Host2, const int &Port2, const int &Proto) {
	this->HostSrc = Host1;
	this->HostDst = Host2;
	this->PortSrc = Port1;
	this->PortDst = Port2;
	this->Protocol = Proto;
	this->GetString();
}

void Tuple::init(const std::string &Host1, const std::string &Port1, const std::string &Host2, const std::string &Port2, const std::string &Proto) {
	this->HostSrc = Host1;
	this->HostDst = Host2;
	this->PortSrc = atoi(Port1.c_str());
	this->PortDst = atoi(Port2.c_str());
	this->Protocol = this->PrototoInt(Proto);
	this->GetString();
}

const std::string Tuple::PrototoString(const int &Proto) const {
	if (Proto == PKT_PTC_UDP)
		return "UDP";
	else if (Proto == PKT_PTC_TCP)
		return "TCP";
	else if (Proto == PKT_PTC_IP)
		return "IP";
	else if (Proto == PKT_PTC_ETHERNET)
		return "ETHERNET";
	else if (Proto == PKT_PTC_NON_ETHERNET)
		return "NON_ETHERNET";
}

const int Tuple::PrototoInt(const std::string &Proto) const {
	if (Proto == "UDP")
		return PKT_PTC_UDP;
	else if (Proto == "TCP")
		return PKT_PTC_TCP;
	else if (Proto == "IP")
		return PKT_PTC_IP;
	else if (Proto == "ETHERNET")
		return PKT_PTC_ETHERNET;
	else if (Proto == "NON_ETHERNET")
		return PKT_PTC_NON_ETHERNET;
}

const std::string Tuple::ToString() const {

	return this->Tup;
}

void Tuple::GetString() {

	this->Tup = this->HostSrc + ":" + this->PorttoString(this->PortSrc) + ":" + this->HostDst + ":" + this->PorttoString(this->PortDst) + ":" + this->PrototoString(this->Protocol);
}

const std::string Tuple::InvTuple() const {

	return this->HostDst + ":" + this->PorttoString(this->PortDst) + ":" + this->HostSrc + ":" + this->PorttoString(this->PortSrc) + ":" + this->PrototoString(this->Protocol);
}

const std::string Tuple::SrcHost() const {
	return this->HostSrc;
}

const std::string Tuple::DstHost() const {
	return this->HostDst;
}

const std::string Tuple::StrSrcPort() const {
	return this->PorttoString(this->PortSrc);
}

const std::string Tuple::StrDstPort() const {
	return this->PorttoString(this->PortDst);
}

const std::string Tuple::StrProto() const {
	return this->PrototoString(this->Protocol);
}

const int Tuple::SrcPort() const {
	return this->PortSrc;
}

const int Tuple::DstPort() const {
	return this->PortDst;
}

const int Tuple::Proto() const {
	return this->Protocol;
}

const std::string Tuple::PorttoString(const int &Port) const {
	std::stringstream ss (std::stringstream::out);
	ss << Port;
	return ss.str();
}

const std::string Tuple::SrcHostPort() const {
	return this->HostSrc + ":" + this->StrSrcPort();
}

const std::string Tuple::DstHostPort() const {
	return this->HostDst + ":" + this->StrDstPort();
}
