/*
 * \author João V. Gomes
 *
 *  tuple.h
 *
 *  Created on: Jan 5, 2011
 *
 * \brief TODO
 * TODO
 */

#ifndef TUPLE_H_
#define TUPLE_H_

#include <pcapwrap.h>
#include <sstream>

class Tuple {
public:
	Tuple();
	Tuple(const std::string &Tup);
	Tuple(const std::string &Host1, const int &Port1, const std::string &Host2, const int &Port2, const int &Proto);
	Tuple(const std::string &HostPort1, const std::string &HostPort2, const int &Proto);
	Tuple(const std::string &Host1, const std::string &Port1, const std::string &Host2, const std::string &Port2, const std::string &Proto);
	virtual ~Tuple();
	const std::string ToString() const;
	const std::string InvTuple() const;
	const std::string SrcHost() const;
	const std::string DstHost() const;
	const std::string StrSrcPort() const;
	const std::string StrDstPort() const;
	const std::string StrProto() const;
	const std::string SrcHostPort() const;
	const std::string DstHostPort() const;
	const int SrcPort() const;
	const int DstPort() const;
	const int Proto() const;

private:
	void init(const std::string &Tup);
	void init(const std::string &Host1, const int &Port1, const std::string &Host2, const int &Port2, const int &Proto);
	void init(const std::string &Host1, const std::string &Port1, const std::string &Host2, const std::string &Port2, const std::string &Proto);
	const std::string PrototoString(const int &Proto) const;
	const int PrototoInt(const std::string &Proto) const;
	const std::string PorttoString(const int &Port) const;
	void GetString();

	std::string HostSrc;
	std::string HostDst;
	int PortSrc;
	int PortDst;
	int Protocol;
	std::string Tup;
};

#endif /* TUPLE_H_ */
