/*
 * \author João V. Gomes
 *
 *  voippattern.h
 *
 *  Created on: Dec 28, 2010
 *
 * \brief TODO
 * TODO
 */

#ifndef VOIPPATTERN_H_
#define VOIPPATTERN_H_

#include <string>

#ifndef PAT_LEVEL
#define PAT_LEVEL
#define PAT_LEVEL_BR 0	// Bitrate level
#define PAT_LEVEL_GR 1	// Group level
#define PAT_LEVEL_CD 2	// Codec level
#endif

class VoIPPattern {
public:
	VoIPPattern();
	VoIPPattern(const int &minLength, const int &maxLength, const double &minEnt, const double &maxEnt, const int &limit, const std::string &sDesc, const std::string &Codec, const int &Level);
	VoIPPattern(const double &minLengthMean, const double &maxLengthMean, const double &minEnt, const double &maxEnt, const int &limit, const std::string &sDesc, const std::string &Codec, const int &Level);
	VoIPPattern(const int &minLength, const int &maxLength, const double &minLengthMean, const double &maxLengthMean, const double &minEnt, const double &maxEnt, const int &limit, const std::string &sDesc, const std::string &Codec, const int &Level);
	virtual ~VoIPPattern();

	const bool Match(const int &len, const double &entropy) const;
	const bool Match(const double &lenMean, const double &entropy) const;
	const bool Match(const int &len, const double &lenMean, const double &entropy) const;
	const std::string Description() const;
	const std::string Codec() const;
	const int Level() const;
	const bool HasTheMin(const int &Val) const;

private:
	void init();
	void init(const int &minLength, const int &maxLength, const double &minLengthMean, const double &maxLengthMean, const double &minEnt, const double &maxEnt, const int &limit, const std::string &sDes, const std::string &Codec, const int &Level);
	void dispose();

	int maxLen;
	int minLen;
	int lim;
	int level;
	double maxLenMean;
	double minLenMean;
	double maxEntropy;
	double minEntropy;
	std::string Desc;
	std::string CodecID;
};

#endif /* VOIPPATTERN_H_ */
